// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
* This file was generated by IBM WebSphere Studio Version 3.0.0
* D:\WebSphere\StudioBeta\BIN\GENERATIONSTYLESHEETS\APPSERVERV2\WEBSPHERE\DatabaseServlet.xsl stylesheet was used to generate this file.
*
* 
*
*/ 
package WebSphereSamples.Counter;

// Imports
import com.ibm.servlet.*;
import com.ibm.webtools.runtime.*;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

// Imports for beans used by this servlet

import WebSphereSamples.Counter.CounterQueryBean;
import WebSphereSamples.Counter.CounterUpdateBean;
import WebSphereSamples.Counter.CounterInsertBean;


public class CounterServlet extends PageListServlet implements Serializable
{


  /*****************************************************************************
  * Process incoming HTTP GET requests
  * 
  * @param request Object that encapsulates the request to the servlet
  * @param response Object that encapsulates the response from the servlet
  */
  public void doGet(HttpServletRequest request, HttpServletResponse response)
  {
    performTask(request, response);
  }
  
  

  /*****************************************************************************
  * Process incoming HTTP POST requests
  * 
  * @param request Object that encapsulates the request to the servlet
  * @param response Object that encapsulates the response from the servlet
  */
  public void doPost(HttpServletRequest request, HttpServletResponse response)
  {
    performTask(request, response);
  }
  
  

  /*****************************************************************************
  * Returns the requested parameter
  * 
  * @param request Object that encapsulates the request to the servlet
  * @param parameterName The name of the parameter value to return
  * @param checkRequestParameters when true, the request parameters are searched
  * @param checkInitParameters when true, the servlet init parameters are searched
  * @param isParameterRequired when true, an exception is thrown when the parameter cannot be found
  * @param defaultValue The default value to return when the parameter is not found
  * @return The parameter value
  * @exception java.lang.Exception Thrown when the parameter is not found
  */
  public java.lang.String getParameter(HttpServletRequest request, String parameterName, boolean checkRequestParameters, boolean checkInitParameters, boolean isParameterRequired, String defaultValue) throws Exception
  {
    String[] parameterValues = null;
    String paramValue = null;

    // Get the parameter from the request object if necessary.
    if (checkRequestParameters)
    {
      parameterValues = request.getParameterValues(parameterName);
      if (parameterValues != null)
        paramValue = parameterValues[0];
    }

    // Get the parameter from the servlet init parameters if
    // it was not in the request parameter.
    if ( (checkInitParameters) && (paramValue == null) )
      paramValue = getServletConfig().getInitParameter(parameterName);

    // Throw an exception if the parameter was not found and it was required.
    // The exception will be caught by error processing and can be
    // displayed in the error page.
    if ( (isParameterRequired) && (paramValue == null) )
      throw new Exception("Parameter" + parameterName + "was not specified.");

    // Set the return to the default value if the parameter was not found
    if (paramValue == null)
      paramValue = defaultValue;

    return paramValue;    
  }


  /*****************************************************************************
  * Process incoming requests for information
  * 
  * @param request Object that encapsulates the request to the servlet
  * @param response Object that encapsulates the response from the servlet
  */
  public void performTask(HttpServletRequest request, HttpServletResponse response)
  {
    try 
    {

      int hits = 0;

      String userID = getParameter(request, "userID", true, true, true, null);
      String password = getParameter(request, "password", true, true, true, null);
      String URL = getParameter(request, "URL", true, true, true, null);
      String driver = getParameter(request, "driver", true, true, true, null);

      String requestURL = request.getRequestURI();

      // instantiate the beans and store them so they can be accessed by the called page
      WebSphereSamples.Counter.CounterQueryBean counterQueryBean = null;
      counterQueryBean = (WebSphereSamples.Counter.CounterQueryBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.Counter.CounterQueryBean");


      // Initialize the bean userID property from the parameters
      counterQueryBean.setUserID(userID);

      // Initialize the bean password property from the parameters
      counterQueryBean.setPassword(password);
      
      // Initialize the bean URL property from the parameters
      counterQueryBean.setURL(URL);

      // Initialize the bean driver property from the parameters
      counterQueryBean.setDriver(driver);

      // Initialize the bean requestURL property from the request
      counterQueryBean.setRequestURL(requestURL);

      // Call the execute action on the bean.
      counterQueryBean.execute();

      try
      {
 
        hits = counterQueryBean.getWSDEMO_COUNTER_HITS(0).intValue();
        hits++;
 
        // Release the database connection
        counterQueryBean.closeResultSet();

 
        // instantiate the beans and store them so they can be accessed by the called page
        WebSphereSamples.Counter.CounterUpdateBean counterUpdateBean = null;
        counterUpdateBean = (WebSphereSamples.Counter.CounterUpdateBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.Counter.CounterUpdateBean");

        // Initialize the bean userID property from the parameters
        counterUpdateBean.setUserID(userID);

        // Initialize the bean password property from the parameters
        counterUpdateBean.setPassword(password);

        // Initialize the bean URL property from the parameters
        counterUpdateBean.setURL(URL);

        // Initialize the bean driver property from the parameters
        counterUpdateBean.setDriver(driver);

        // Initialize the bean requestURL property from the request
        counterUpdateBean.setRequestURL(requestURL);

        // Set the hits property
        counterUpdateBean.setHits(String.valueOf(hits));

        // Call the execute action on the bean.
        counterUpdateBean.execute();
        
        // Release the database connection
        counterUpdateBean.closeResultSet();

      }     
      catch (ArrayIndexOutOfBoundsException e)
      {
        hits = 1;

        WebSphereSamples.Counter.CounterInsertBean counterInsertBean = null;
        counterInsertBean = (WebSphereSamples.Counter.CounterInsertBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.Counter.CounterInsertBean");

        // Initialize the bean userID property from the parameters
        counterInsertBean.setUserID(userID);

        // Initialize the bean password property from the parameters
        counterInsertBean.setPassword(password);
      
        // Initialize the bean URL property from the parameters
        counterInsertBean.setURL(URL);

        // Initialize the bean driver property from the parameters
        counterInsertBean.setDriver(driver);
        
        // Initialize the bean requestURL property from the request
        counterInsertBean.setRequestURL(requestURL);
        
        // Call the execute action on the bean.
        counterInsertBean.execute();
        
        // Release the database connection
        counterInsertBean.closeResultSet();
      }

      //sets type of text output to ascii otherwise binary output is used on some systems
      response.setContentType("text/html");
      PrintWriter out = response.getWriter();

      out.println(hits);

    }

    catch (Exception theException)
    {
      System.out.println(theException.getMessage());
      handleError(request, response, theException);
    }
  }

}
